/***************************************************************************
	adtek_8133_O_02.c 
	2001/04/19	by m.tadano
	cc -c -g -Wall -O -v adtek_8133_O_02.c -o adtek_8133.o -DDDRIVER
	# mknod -m 666 /dev/adtek_8133 c 251 0
	# insmod adtek_8133.o major=251	(set major number FIX assignment)
	# insmod adtek_8133.o		(set major number AUTO assignment)

****************************************************************************/

#ifndef	MODULE
#define	MODULE
#endif
#ifndef	__KERNEL__
#define	__KERNEL__
#endif

#include <linux/version.h>
#include <linux/init.h>
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/sched.h>
#include <linux/wait.h>
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/signal.h>
#include <linux/major.h>
#include <linux/module.h>
#include <linux/tqueue.h>
#include <linux/interrupt.h>
#include <linux/ioport.h>
#include <linux/poll.h>
#include <linux/mm.h>
#include <linux/pci.h>
#include <linux/malloc.h>
#include <asm/system.h>
#include <asm/io.h>
#include <asm/uaccess.h>

#include "adtek_8133_O.h"

static unsigned int	busy = 0;
static struct pci_dev	*pci_device = NULL;
static dDriver_t dDriver;
typedef struct	{
	u8	data;
	int	port;
}	set_up_t;
static set_up_t	*setup;

static int	adr_port[9];
static int	major = 0;
MODULE_PARM (major, "i");

/* open **********************************************************************/
static int adtek_8133_open (struct inode *inode, struct file *file)
{
int	minor;

printk ("adtek_8133_open/ ");
	if (busy != 0) 	{
		return - EBUSY;
	}
	minor = MINOR (inode->i_rdev);
	if (minor < 0)	{
  		return -ENODEV;
	}
	busy = 1;
	MOD_INC_USE_COUNT;

	dDriver.minor = minor;

printk ("adtek_8133_open/ return\n");
	return 0;
}

/* close *********************************************************************/
static int adtek_8133_close (struct inode *inode, struct file *file)
{
printk ("adtek_8133_close/ ");

	busy = 0;
	MOD_DEC_USE_COUNT;
	
printk ("adtek_8133_close/ return\n");
	return 0;
}

/* write *********************************************************************/
static ssize_t adtek_8133_write (
	struct file *file, const char *buf, size_t count, loff_t *ppos)
{
u8	w_data;
int	port_num;
	
	setup = (set_up_t *)buf;
	w_data = setup->data;
	port_num = setup->port;
	outb (w_data, adr_port[port_num]);

	return 0;
}

/* file_operations ***********************************************************/
static struct file_operations adtek_8133_fops =
{
  owner:	THIS_MODULE,
  write:	adtek_8133_write,
  open:		adtek_8133_open,
  release:	adtek_8133_close,
};

/* init_module ***************************************************************/
int init_module (void)
{
struct pci_dev	*ret_dev;
int	result, i;

	printk ("init_module/adtek_8133/ ");
	ret_dev = pci_find_device (ADTEK_8133_IN_BOARD_VENDOR,
                              ADTEK_8133_IN_BOARD_DEVICE, pci_device);
	if (!ret_dev)
		return -ENODEV;         /* not found */

	pci_device = ret_dev;
	result = pci_enable_device (pci_device);
	if (result)
		return result;
	dDriver.iobase0 = pci_resource_start (pci_device, 0);
	dDriver.iobase1 = pci_resource_start (pci_device, 1);
	dDriver.iobase2 = pci_resource_start (pci_device, 2);
	dDriver.iobase3 = pci_resource_start (pci_device, 3);
	dDriver.iobase4 = pci_resource_start (pci_device, 4);
	dDriver.iobase5 = pci_resource_start (pci_device, 5);
	dDriver.irq = pci_device ->irq;
	request_region (dDriver.iobase1, 16, DEVICE_NAME);

	result = register_chrdev (major, DEVICE_NAME, &adtek_8133_fops);
	if (result < 0)	{
		unregister_chrdev (major, DEVICE_NAME);
		return - EIO;
	}
	if (major == 0)
	  	dDriver.major = result;
	else
		dDriver.major = major;
	
	adr_port[0] = dDriver.iobase1;		/* not used */
	for (i = 1; i <= MAX_PORT; i++)
		adr_port[i] = dDriver.iobase1 + i-1;

	printk ("iobase0=%x ", dDriver.iobase0);
	printk ("iobase1=%x ", dDriver.iobase1);
	printk ("iobase2=%x ", dDriver.iobase2);
	printk ("iobase3=%x ", dDriver.iobase3);
	printk ("iobase4=%x ", dDriver.iobase4);
	printk ("iobase5=%x ", dDriver.iobase5);
	printk ("irq=%d \n", dDriver.irq);

	printk ("init_module/adtek_8133/end\n");
	return 0;
}
/* ***************************************************************************/
void cleanup_module (void)
{
printk ("cleanup_module\n");
	release_region (dDriver.iobase1, 16);
	unregister_chrdev (dDriver.major, DEVICE_NAME);
printk ("cleanup_module/adtek_8133/end\n");
}
/* end of file ***************************************************************/
