/*
	advanet_1108_PCIVME.h
	2001/05/12 by M.Tadano
*/

#ifdef DDRIVER
#define	ADVANET_1108_PCIVME_BOARD_VENDOR	0x130f
#define	ADVANET_1108_PCIVME_BOARD_DEVICE	0x00a0
#define	DEVICE_NAME			"advanet_1108"

#define L_VMESBASE	dDriver.iobase0		/* VME A16/D16 access */
#define L_VMEBASE	dDriver.iobase0		/* VME A24/D16 access */

typedef struct {
        int     memory;
        int     iobase0;
        int     iobase1;
        int     iobase2;
        int     iobase3;
        int     iobase4;
        int     iobase5;
        unsigned int    irq;
        wait_queue_head_t       queue;
        int     f_pos;
        int     major;
        int     minor;
} dDriver_t;
#endif

#define	EAR		0x01		/* PCI register offset address */
#define	BCR		0x03		/* PCI register offset address */
#define	PIMR		0x04		/* PCI register offset address */
#define	PISR		0x06		/* PCI register offset address */
#define	SMAR		0x08		/* PCI register offset address */
#define	FCR		0x0c		/* PCI register offset address */
#define	PFWR		0x10		/* PCI register offset address */
#define	PFRR		0x14		/* PCI register offset address */
#define	IVR1		0x19		/* PCI register offset address */
#define	IVR2		0x1a		/* PCI register offset address */
#define	IVR3		0x1b		/* PCI register offset address */
#define	IVR4		0x1c		/* PCI register offset address */
#define	IVR5		0x1d		/* PCI register offset address */
#define	IVR6		0x1e		/* PCI register offset address */
#define	IVR7		0x1f		/* PCI register offset address */

#define	SCL_ADR1	0x100000	/* rpv-100 */
#define	SCL_ADR2	0x100200	/* rpv-100 */
#define	SCL_ADR3	0x100400	/* rpv-100 */
#define	IO_ADR		0x0000		/* rpv-130 */
#define	SET_LATCH1	0x00		/* RPV-130 offset address */
#define	SET_LATCH2	0x02		/* RPV-130 offset address */
#define	SET_RS_FF	0x04		/* RPV-130 offset address */
#define	SET_THROUGH	0x06		/* RPV-130 offset address */
#define	SET_PULSE	0x08		/* RPV-130 offset address */
#define	SET_LEVEL	0x0a		/* RPV-130 offset address */
#define	SET_CSR1	0x0c		/* RPV-130 offset address */
#define	SET_CSR2	0x0e		/* RPV-130 offset address */
#define	ENABLE3		0x40		/* RPV-130 write data */
#define	ENABLE12	0x10		/* RPV-130 write data */
#define	MASK12		0x08		/* RPV-130 write data */
#define	CLR12		0x02		/* RPV-130 write data */
#define	CLR3		0x01		/* RPV-130 write data */
#define	SCL_CH0_U	0x00		/* RPV-100 offset address */
#define	SCL_CH0_L	0x02		/* RPV-100 offset address */
#define	SCL_CH1_U	0x04		/* RPV-100 offset address */
#define	SCL_CH1_L	0x06		/* RPV-100 offset address */
#define	SCL_CH2_U	0x08		/* RPV-100 offset address */
#define	SCL_CH2_L	0x0a		/* RPV-100 offset address */
#define	SCL_CH3_U	0x0c		/* RPV-100 offset address */
#define	SCL_CH3_L	0x0e		/* RPV-100 offset address */
#define	SCL_CH4_U	0x00		/* RPV-100 offset address */
#define	SCL_CH4_L	0x02		/* RPV-100 offset address */
#define	SCL_CH5_U	0x04		/* RPV-100 offset address */
#define	SCL_CH5_L	0x06		/* RPV-100 offset address */
#define	SCL_CH6_U	0x08		/* RPV-100 offset address */
#define	SCL_CH6_L	0x0a		/* RPV-100 offset address */
#define	SCL_CH7_U	0x0c		/* RPV-100 offset address */
#define	SCL_CH7_L	0x0e		/* RPV-100 offset address */
#define CHANNEL_MAX	8

#define	READ_COMMAND	10
#define	WRITE_COMMAND	20
#define	OTHER_COMMAND	30
enum status		{OFF, ON};
enum vme_command	{
		SET_INTERVAL=1,
		WRITE_BIT, READ_BIT, 
		VME_READ_A16_D8 = READ_COMMAND, 
		VME_READ_A24_D8, VME_READ_A24_D16,
		VME_WRITE_A16_D8 = WRITE_COMMAND, 
		VME_WRITE_A24_D8, VME_WRITE_A24_D16,
		LOSS_READ = OTHER_COMMAND
		};

typedef struct	{
	short	mode;
	short	number;
	int	interval_sec;
	int	interval_usec;
	unsigned char	w_bit;
	unsigned char	r_bit;
} set_up_t;

typedef struct	{
	short		command;
	unsigned long	address;	/* VME board address */
	int		count;
	unsigned char	w_bit;
	unsigned char	r_bit;
	int		data[16];
} vme_fn;
/* end of file ***************************************************************/
