/*
	advanet_1108 device driver check program	check1108_10.c
	2001/05/12	by M.tadano
	usage	:	check1108 1 1000 100	
			check1108 'number' 'interval[sec]' 'interval[usec]'
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/stat.h>
#include	<sys/ioctl.h>
#include	<signal.h>

#include	"advanet_1108_PCIVME.h"


int main (int argc, char **argv)
{
int	fd, i, j;
long int	 data, data1, data2;
vme_fn		*set_vme;
int		io_address, scl_address;
short		number = 0;
short		*read_buf;
long int	interval_sec = 0, interval_usec = 0;

	printf ("program start\n");
	io_address = IO_ADR + SET_LEVEL;
	scl_address = SCL_ADR1;
	if (1 < argc )
		number = atoi (argv[1]);
	if (number == 0)	{
		printf ("number of scaler board ( 1 - 3 )?");
		scanf ("%d", (int *)&number);
	}
	if (3 <= number)
		number = 3;
	if (2 < argc)
		interval_sec = atoi (argv[2]);
	if (interval_sec == 0)	{
		printf ("sampring interval [unit:sec] ? ");
		scanf ("%d", (int *)&interval_sec);
	}
	if (3 < argc)
		interval_usec = atoi (argv[2]);
	if (interval_usec == 0)	{
		printf ("sampring interval [unit:usec] ? ");
		scanf ("%d", (int *)&interval_usec);
	}
	if (interval_sec == 0)
		interval_sec = 1;	/* set at 1[sec] */

	if ((fd = open ("/dev/advanet_1108", O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}
	read_buf = (short *)malloc (sizeof (short)*16);
	if (read_buf == NULL)	{
		perror ("malloc error:");
		return -1;
	}
	set_vme = (vme_fn *)malloc (sizeof (vme_fn));
	if (set_vme == NULL)	{
		perror ("malloc error(set_vme):");
		return -1;
	}

	printf ("get memory size %d\n", sizeof (read_buf));
	printf ("number = %d interval = %ld %ld\n", 
			number, interval_sec, interval_usec);
	set_vme->command = VME_WRITE_A16_D8;
	set_vme->address = io_address;

	set_vme->command = VME_WRITE_A16_D8;
	set_vme->count = 1;
	set_vme->w_bit = 0x00;			/* scaler stop */
	printf ("device file write\n");
	if (write (fd, (char *)set_vme, set_vme->count) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	set_vme->w_bit = 0x02;			/* scaler reset */
	if (write (fd, (char *)set_vme, set_vme->count) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	set_vme->w_bit = 0x01;			/* scaler start */
	if (write (fd, (char *)set_vme, set_vme->count) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	sleep (interval_sec);
	set_vme->count = 1;
	set_vme->w_bit = 0x00;			/* scaler stop */
	if (write (fd, (char *)set_vme, set_vme->count) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}

	for (i = 1; i<= number; i++)	{
		printf ("device file read\n");
		set_vme = (vme_fn *)read_buf;
		set_vme->command = VME_READ_A24_D16;
		if (i == 1)
			set_vme->address = SCL_ADR1 + SCL_CH0_U;
		else if (i == 2)
			set_vme->address = SCL_ADR2 + SCL_CH0_U;
		else
			continue;

		set_vme->count = 16;
#ifndef IOCTL
		read (fd, (char *)read_buf, 16);
		printf ("read used.\n");
#endif
#ifdef	IOCTL
		ioctl (fd, VME_READ_A24_D16, (unsigned long *)read_buf);
		printf ("ioctl used.\n");
#endif
		for (j = 0; j < CHANNEL_MAX; j++)	{
			data = *(read_buf+j*2);
			data1 = (((data & 0xf000) >> 12)*1000
				+ ((data & 0xf00) >> 8)*100
				+ ((data & 0xf0) >> 4)*10
				+ (data & 0xf));
			data = *(read_buf+j*2+1);
			data2 = (((data & 0xf000) >> 12)*1000
				+ ((data & 0xf00) >> 8)*100
				+ ((data & 0xf0) >> 4)*10
				+ (data & 0xf));
			data = data1*10000+data2;
			printf ("adr=%8x data=%4ld %4ld ", 
					read_buf+j*2, data1, data2);
			printf ("scaler count =%8ld\n", data);
		}
	}

	set_vme->command = VME_WRITE_A16_D8;
	set_vme->address = io_address;
	set_vme->count = 1;
	set_vme->w_bit = 0x02;			/* scaler reset */
	if (write (fd, (char *)set_vme, set_vme->count) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	set_vme->w_bit = 0x01;			/* scaler start */
	if (write (fd, (char *)set_vme, set_vme->count) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	close (fd);
	printf ("program end\n");
	exit (0);
}
/* end of file ***************************************************************/
