/*
	advanet_1108 device driver check program	measure_1108_03.c
	2001/05/18	by M.tadano
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/stat.h>
#include	<sys/ioctl.h>

#include	"../advanet_1108_PCIVME.h"

#define	LOOP	10000

/* main **********************************************************************/
int main (int argc, char **argv)
{
int     min_max (int loop, int *e_time, int overhead, int *min, int *max);
struct timeval	timevalue0[LOOP], timevalue1[LOOP];
int		elapsed[LOOP], average, overhead, min, max;
int		fd, i;
vme_fn		*set_vme;
int		io_address, scl_address;
short		number = 0;
short		*read_buf;
int		readlength;
long int	interval_sec = 0, interval_usec = 0;

	printf ("program start\n");
        if (1 < argc )
                readlength = atoi (argv[1]);
        if (readlength == 0)        {
                printf ("measure readlength (1 - 16) ?");
                scanf ("%d", (int *)&readlength);
        }
	if ( readlength < 1 || 16 < readlength)
		readlength = 1;

	io_address = IO_ADR + SET_LEVEL;
	scl_address = SCL_ADR1;
	readlength = 10;		/* value is from 1 to 16 */
	number = 1;
	interval_usec = 0;
	interval_sec = 1;	/* set at 1[sec] */

	if ((fd = open ("/dev/advanet_1108", O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}
	read_buf = (short *)malloc (sizeof (short)*16);
	if (read_buf == NULL)	{
		perror ("malloc error:");
		return -1;
	}
	set_vme = (vme_fn *)malloc (sizeof (vme_fn));
	if (set_vme == NULL)	{
		perror ("malloc error(set_vme):");
		return -1;
	}

	set_vme->command = VME_WRITE_A16_D8;
	set_vme->address = io_address;
	set_vme->count = 1;
	set_vme->w_bit = 0x00;			/* scaler stop */
	printf ("device file write\n");
	if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	set_vme->w_bit = 0x02;			/* scaler reset */
	if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	set_vme->w_bit = 0x01;			/* scaler start */
	if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	sleep (interval_sec);
	set_vme->w_bit = 0x00;			/* scaler stop */
	if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}

	overhead = average = max = 0;
	min = 9999;
	for ( i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	printf ("overhead %d / %d microsecond.\n", overhead, LOOP);
	overhead /= LOOP;

	set_vme = (vme_fn *)read_buf;
	for (i = 0; i < LOOP; i++)	{
		set_vme->command = VME_READ_A24_D16;
		set_vme->count = readlength;
		set_vme->address = scl_address + SCL_CH0_U;
		get_time (&timevalue0[i]);
		read (fd, (char *)read_buf, readlength);
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Advanet 1108 cPCI/VME bus brigde/RPV-100 8ch read\n");
	printf ("	VME_READ_A24_D16 access takes %5d microsecond.\n",
							average);
	printf ("	                      minimum %5d microsecond.\n",
								min);
	printf ("	                      maximum %5d microsecond.\n",
								max);
	overhead = average = max = 0;
	min = 9999;
	for ( i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	printf ("overhead %d / %d microsecond.\n", overhead, LOOP);
	overhead /= LOOP;

	for (i = 0; i < LOOP; i++)	{
		set_vme->command = VME_READ_A24_D16;
		set_vme->address = scl_address + SCL_CH0_U;
		set_vme->count = readlength;
		get_time (&timevalue0[i]);
		ioctl (fd, VME_READ_A24_D16, (unsigned long *)set_vme);
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Advanet 1108 cPCI/VME bus brigde/RPV-100 8ch ioctl\n");
	printf ("	VME_READ_A24_D16 access takes %5d microsecond.\n",
							average);
	printf ("	                      minimum %5d microsecond.\n",
								min);
	printf ("	                      maximum %5d microsecond.\n",
								max);
	overhead = average = max = 0;
	min = 9999;
	for ( i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	printf ("overhead %d / %d microsecond.\n", overhead, LOOP);
	overhead /= LOOP;

	for (i = 0; i < LOOP; i++)	{
		set_vme->command = VME_READ_A16_D8;
		set_vme->address = IO_ADR + SET_CSR1;
		set_vme->count = 1;
		set_vme->w_bit = 0x02;
		get_time (&timevalue0[i]);
		if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
			printf ("write error !!!!!\n");
			exit;
		}
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Advanet 1108 cPCI/VME bus brigde/RPV-130 8ch read\n");
	printf ("	VME_READ_A16_D8 access takes %5d microsecond.\n",
							average);
	printf ("	                     minimum %5d microsecond.\n",
								min);
	printf ("	                     maximum %5d microsecond.\n",
								max);
	overhead = average = max = 0;
	min = 9999;
	for ( i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	printf ("overhead %d / %d microsecond.\n", overhead, LOOP);
	overhead /= LOOP;

	for (i = 0; i < LOOP; i++)	{
		set_vme->command = VME_READ_A16_D8;
		set_vme->address = IO_ADR + SET_CSR1;
		set_vme->count = 1;
		set_vme->w_bit = 0x02;
		get_time (&timevalue0[i]);
		ioctl (fd, VME_READ_A16_D8, (unsigned long *)set_vme);
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Advanet 1108 cPCI/VME bus brigde/RPV-130 8ch ioctl\n");
	printf ("	VME_READ_A16_D8 access takes %5d microsecond.\n",
							average);
	printf ("	                     minimum %5d microsecond.\n",
								min);
	printf ("	                     maximum %5d microsecond.\n",
								max);
	overhead = average = max = 0;
	min = 9999;
	for ( i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	printf ("overhead %d / %d microsecond.\n", overhead, LOOP);
	overhead /= LOOP;

	for (i = 0; i < LOOP; i++)	{
		set_vme->command = VME_WRITE_A16_D8;
		set_vme->address = io_address;
		set_vme->count = 1;
		set_vme->w_bit = 0x02;			/* scaler reset */
		get_time (&timevalue0[i]);
		if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
			printf ("write error !!!!!\n");
			exit;
		}
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Advanet 1108 cPCI/VME bus brigde/RPV-130 8ch write\n");
	printf ("	VME_WRITE_A16_D8 access takes %5d microsecond.\n",
							average);
	printf ("	                      minimum %5d microsecond.\n",
								min);
	printf ("	                      maximum %5d microsecond.\n",
								max);
	overhead = average = max = 0;
	min = 9999;
	for ( i = 0; i < LOOP; i++)	{
		get_time (&timevalue0[i]);
		get_time (&timevalue1[i]);
		overhead += e_time (&timevalue0[i], &timevalue1[i]);
	}
	printf ("overhead %d / %d microsecond.\n", overhead, LOOP);
	overhead /= LOOP;

	for (i = 0; i < LOOP; i++)	{
		set_vme->command = VME_WRITE_A16_D8;
		set_vme->address = io_address;
		set_vme->count = 1;
		set_vme->w_bit = 0x02;			/* scaler reset */
		get_time (&timevalue0[i]);
		ioctl (fd, VME_WRITE_A16_D8, (unsigned long *)set_vme);
		get_time (&timevalue1[i]);
	}
	for (i = 0; i < LOOP; i++)
		elapsed[i] = e_time (&timevalue0[i], &timevalue1[i]);
        average = min_max (LOOP, &elapsed[0], overhead, &min, &max);

	printf ("Advanet 1108 cPCI/VME bus brigde/RPV-130 8ch ioctl\n");
	printf ("	VME_WRITE_A16_D8 access takes %5d microsecond.\n",
							average);
	printf ("	                      minimum %5d microsecond.\n",
								min);
	printf ("	                      maximum %5d microsecond.\n",
								max);
	set_vme->command = VME_WRITE_A16_D8;
	set_vme->address = io_address;
	set_vme->count = 1;
	set_vme->w_bit = 0x02;			/* scaler reset */
	if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	set_vme->w_bit = 0x01;			/* scaler start */
	if (write (fd, (char *)set_vme, sizeof (set_vme)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}
	close (fd);
	printf ("program end\n");
	exit (0);
}
/*****************************************************************************/
int     min_max (int loop, int *e_time, int overhead, int *min, int *max)
{
int     i, average;

        average = 0;
        for (i = 0; i < loop; i++)      {
                if (*(e_time+i) < *min) {
                        *min = *(e_time+i) - overhead;
                        printf ("i=%d min=%d max=%d\n", i, *min, *max);
                }
                if (*max < *(e_time+i)) {
                        *max = *(e_time +i) - overhead;
                        printf ("i=%d min=%d max=%d\n", i, *min, *max);
                }
                average += *(e_time+i) - overhead;
        }
        average /= loop;
        return average;
}
/* ***************************************************************************/
get_time (timevalue)
struct timeval  *timevalue;
{
struct timezone tzp;

        gettimeofday (timevalue, &tzp);
}
/* ***************************************************************************/
int     e_time (first, second)
struct timeval  *first, *second;
{

        if (first->tv_usec > second->tv_usec)   {
                second->tv_usec += 1000000;
                second->tv_sec--;
        }
        return ((int)(second->tv_sec - first->tv_sec)*1000000
                + (int)(second->tv_usec - first->tv_usec));
}
/* end of file ***************************************************************/
