/*
	advanet_2610 device driver check program	check2610_4.c
	2001/04/18	by M.tadano
	usage	:	check2610 1 1000 100	
			check2610 'mode' 'interval' 'max_count'
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/stat.h>
#include	<sys/ioctl.h>

#include	"advanet_2610_AD.h"

int main (int argc, char **argv)
{
int	fd, len, i, j, data;
int	loopcount;
set_up_t	setup;
short		mode = 0, *read_buf;
int		count = 0, count2 = 0;
long int	interval = 0;

	printf ("program start\n");
	if (1 < argc )
		mode = atoi (argv[1]);
	if (mode == 0)	{
		printf ("sampring mode 1:single 2:mutiple 3:continue ? ");
		scanf ("%d", (int *)&mode);
	}
	switch (mode)	{
	case 1:
		mode = SINGLE_MULTICHN;
		count = 1;
		break;
	case 2:
		mode = MULTI_MULTICHN;
		break;
	case 3:
		mode = CONTINUAS_MULTICHN;
		count = 1;
		break;
	case 4:				/* EEPROM read */
		mode = EEPROM_READ;
		count = 1;
		break;
	default:
		mode = SINGLE_MULTICHN;
		count = 1;
		break;
	}
	if (2 < argc)
		interval = atoi (argv[2]);
	if ((interval == 0) &&
			(mode == MULTI_MULTICHN || mode == CONTINUAS_MULTICHN))	{
		printf ("sampring interval [unit:usec] ? ");
		scanf ("%d", (int *)&interval);
	}
	if (interval == 0)
		interval = 1000;	/* set at 1[msec] */

	if ((fd = open ("/dev/advanet_2610", O_RDWR)) == -1)	{
		perror ("file open error:");
		return -1;
	}
	if (3 < argc )
		count = atoi (argv[3]);
	if (count == 0)	{
		printf ("sampring number ? ");
		scanf ("%d", &count);
	}
	read_buf = (short *)malloc(sizeof(unsigned short)*count*CHANNEL_MAX);
	if (read_buf == NULL)	{
		perror ("malloc error:");
		return -1;
	}
	printf ("get memory size %d\n",
			sizeof (unsigned short)*count*CHANNEL_MAX);
	setup.mode = mode;
	setup.count = count;
	setup.interval = interval;		/* unit [msec] */
	printf ("mode = %d count %d interval = %d\n", mode, count, interval);
	printf ("device file write\n");
	if (write (fd, (char *)&setup, sizeof (setup)) != 0)	{
		printf ("write error !!!!!\n");
		exit;
	}

	count = 0;
	loopcount = setup.count;
	printf ("device file read\n");
	switch (mode)	{
	case EEPROM_READ:
		printf ("advanet_2610 EEPROM read\n");
		ioctl (fd, EEPROM_READ+0x0, &data);
		printf ("EEPROM +/-10V offset(Diff.) %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x1, &data);
		printf ("EEPROM +/-10V gain(Diff.)   %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x2, &data);
		printf ("EEPROM 0-10V offset(Diff.)  %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x3, &data);
		printf ("EEPROM 0-10V gain(Diff.)    %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x4, &data);
		printf ("EEPROM 0-5V ofset(Diff.)    %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x5, &data);
		printf ("EEPROM 0-5V gain(Diff.)     %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x6, &data);
		printf ("EEPROM +/-10V offset(single end) %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x7, &data);
		printf ("EEPROM +/-10V gain(single end)   %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x8, &data);
		printf ("EEPROM 0-10V offset(single end)  %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0x9, &data);
		printf ("EEPROM 0-10V gain(single end)    %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0xa, &data);
		printf ("EEPROM 0-5V offset(single end)   %d(hex:%x)\n", data, data);
		ioctl (fd, EEPROM_READ+0xb, &data);
		printf ("EEPROM 0-5V gain(single end)     %d(hex:%x)\n", data, data);

		break;
	case SINGLE_MULTICHN:
	case MULTI_MULTICHN:
	case CONTINUAS_MULTICHN:
	defaults:
		do	{
		len = read (fd, read_buf, loopcount);
		if (len == 0)	{
			printf (" len=0 ");
			continue;
		}
		count2 += len;
		if (count2 < setup.count)
			continue;
		printf ("\t\t\t\t\t  Hex  Raw   Conv.\n");
		for (i = 0; i < setup.count; i++)	{
			if ((mode == CONTINUAS_MULTICHN) ||
					(mode == CONTINUAS_SINGLECHN))
				count++;
			for (j = 0; j < CHANNEL_MAX; j++)	{
				data = *(read_buf+i*CHANNEL_MAX+j) & 0xffff;
				printf ("count:%4d  address:%4x ",
					i+count*setup.count,
					(read_buf+i*CHANNEL_MAX+j));
				printf ("chn = %2d data:%4x %5d %f\n",
					j, data, data, 10.24*(data-0x8000)/32768.0);
			}
		}
		} while ((mode == CONTINUAS_MULTICHN) || (mode == CONTINUAS_SINGLECHN));
		break;
	}

	close (fd);
	printf ("program end\n");
	exit (0);
}
