/*
	cputime.c
	2001.04.13
*/

#include	<sys/times.h>
#include	<unistd.h>
#include	<stdio.h>

void	print_times (char *title, clock_t real, int loop,
		struct tms *start, struct tms *end)
{
int	clktck;
float	etime, cputime;

	clktck =sysconf (_SC_CLK_TCK);
	printf ("%s\n", title);
	etime = (float)real / (double) clktck *1000000. / (float)loop;
	cputime = (float)(end->tms_utime - start->tms_utime) +
		(float)(end->tms_stime - start->tms_stime);
	cputime = cputime / (double)clktck * 1000000. / (float)loop;
	printf ("	elapsed time : %f microsec.\n", etime);
	printf ("	cpu time     : %f microsec.\n", cputime);
}

main (int argc, char **argv)
{
int	i, loop;
clock_t	start, end;
struct tms	tmsstart, tmsend;

	if (argc < 2)
		loop = 1000000;
	else
		loop = atoi (argv[1]);
	
	start = times (&tmsstart);
	for ( i = 0; i < loop; i++)	{
	}
	end = times (&tmsend);
	print_times ("Measurement", end - start, loop, &tmsstart, &tmsend);
}

